var spinner;
var target;

function startLoading()
{
	if(target == null)
		target = document.getElementById('floatingCircles')

	//if(spinner == null)
		spinner = new Spinner().spin();
	
	target.appendChild(spinner.el);
}
function stopLoading()
{
	if(spinner != null)
		spinner.stop();
}

function handleDeviceSwitch(button)
{
	//alert("Clicked, new value = " + button.checked);

	/*
		String, name: objectType, value (not case-sensitive): Command | Device | Room | All
		String, name: objectName, value (case-sensitive): whatever you named your command/device/room
		boolean, name: desiredState, value: true | false
	*/

	// http://www.tizag.com/ajaxTutorial/ajaxxmlhttprequest.php

	var ajaxRequest;

	try
	{
		// Opera 8.0+, Firefox, Safari
		ajaxRequest = new XMLHttpRequest();
	}
	catch (e)
	{
		// Internet Explorer Browsers
		try
		{
			ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch (e)
		{
			try
			{
				ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch (e)
			{
				// Something went wrong
				alert("Your browser doesn't support ajax requests. Sending request the old-fashioned way.");
				postToUrl(window.location.href, {objectType: "device", objectName: button.id, desiredState: button.checked});
				return false;
			}
		}
	}

	// Create a function that will receive data sent from the server
	ajaxRequest.onreadystatechange = function()
		{
			if(ajaxRequest.readyState == 4)
			{
				// Receive and use response
				// stop waiting animation if there is one
				//alert('Server has responded:' + ajaxRequest.responseText);
				if(ajaxRequest.responseText == "SUCCESS")
				{
					button.checked = button.checked;
				}
				else
				{
					button.checked = !(button.checked);
				}

				stopLoading();
				//document.myForm.time.value = ajaxRequest.responseText;
				if(ajaxRequest.responseText == "SUCCESS")
				{
					toastSuccess("Device switched successfully.");
				}
				else
				{
					toastError("Device could not be switched.");
				}
			}
		}

	startLoading();

	//ajaxRequest.open("GET", "serverTime.php", true);
	ajaxRequest.open("POST", "ajaxHandler.html", true);
	ajaxRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

	// transform the request
	var textRequest = postToAjax({objectType: "device", objectName: button.id, desiredState: button.checked});
	//alert("Sending request: " + textRequest);
	ajaxRequest.send(textRequest);	// syntax example: "fname=Henry&lname=Ford"
}

function handleRuleExecution(ruleId)
{
	/*
		String, name: objectType, value (not case-sensitive): Command | Device | Room | All
		String, name: objectName, value (case-sensitive): whatever you named your command/device/room
		boolean, name: desiredState, value: true | false
	*/

	// http://www.tizag.com/ajaxTutorial/ajaxxmlhttprequest.php

	var ajaxRequest;

	try
	{
		// Opera 8.0+, Firefox, Safari
		ajaxRequest = new XMLHttpRequest();
	}
	catch (e)
	{
		// Internet Explorer Browsers
		try
		{
			ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch (e)
		{
			try
			{
				ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch (e)
			{
				// Something went wrong
				alert("Your browser doesn't support ajax requests. Sending request the old-fashioned way.");
				postToUrl(window.location.href, {objectType: "rule", objectName: ruleId, command: "run"});
				return false;
			}
		}
	}

	// Create a function that will receive data sent from the server
	ajaxRequest.onreadystatechange = function()
		{
			if(ajaxRequest.readyState == 4)
			{
				// Receive and use response
				// stop waiting animation if there is one
				//alert('Server has responded:' + ajaxRequest.responseText);

				//alert("Bin hier: " + ajaxRequest.responseText);

				stopLoading();
				//document.myForm.time.value = ajaxRequest.responseText;
				if(ajaxRequest.responseText == "SUCCESS")
				{
					toastSuccess("Rule executed successfully.");
				}
				else
				{
					toastError("There were errors while executing the rule.");
				}
			}
		}

	startLoading();

	//ajaxRequest.open("GET", "serverTime.php", true);
	ajaxRequest.open("POST", "ajaxHandler.html", true);
	ajaxRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

	// transform the request
	var textRequest = postToAjax({objectType: "rule", objectName: ruleId, command: "run"});
	//alert("Sending request: " + textRequest);
	ajaxRequest.send(textRequest);	// syntax example: "fname=Henry&lname=Ford"
}

function handleCommandExecution(selectGroup)
{
	var selectedValue = selectGroup.options[selectGroup.selectedIndex].value;

	if(selectedValue != "dummy")
	{
		//alert("Submitting command = " + selectItem.value);

		/*
			String, name: objectType, value (not case-sensitive): Command | Device | Room | All
			String, name: objectName, value (case-sensitive): whatever you named your command/device/room
			boolean, name: desiredState, value: true | false
		*/

		postToUrl(window.location.href, {objectType: "command", objectName: selectedValue, desiredState: true});
	}
}

function handleRoomSwitch(button)
{
	var desiredState = "off";
	if(button.value == "true")
		desiredState = "on";

	if(confirm("Are you sure you want to switch " + desiredState + " every device in " + button.name  + "?"))
	{
		/*
			String, name: objectType, value (not case-sensitive): Command | Device | Room | All
			String, name: objectName, value (case-sensitive): whatever you named your command/device/room
			boolean, name: desiredState, value: true | false
		*/

		postToUrl(window.location.href, {objectType: "room", objectName: button.id, desiredState: button.value});
	}
}

function handleDeviceGroupSwitch(button)
{
	var desiredState = "off";
	if(button.value == "true")
		desiredState = "on";

	if(confirm("Are you sure you want to switch " + desiredState + " device group " + button.name  + "?"))
	{
		/*
			String, name: objectType, value (not case-sensitive): Command | Device | Room | All
			String, name: objectName, value (case-sensitive): whatever you named your command/device/room
			boolean, name: desiredState, value: true | false
		*/

		postToUrl(window.location.href, {objectType: "deviceGroup", objectName: button.id, desiredState: button.value});
	}
}

function handleCompleteSwitch(button)
{
	var desiredState = "off";
	if(button.value == "true")
		desiredState = "on";

	if(confirm("Are you sure you want to switch every device " + desiredState + "?"))
	{
		/*
			String, name: objectType, value (not case-sensitive): Command | Device | Room | All
			String, name: objectName, value (case-sensitive): whatever you named your command/device/room
			boolean, name: desiredState, value: true | false
		*/

		postToUrl(window.location.href, {objectType: "all", objectName: "", desiredState: button.value});
	}
}

function notImplementedYet()
{
	alert ("This feature is not implemented, yet. Please wait for an upcoming version.");
}

function postToAjax(data)
{
	var returnString = "";

    function constructElements(item, parentString)
	{
        for (var key in item)
		{
            if (item.hasOwnProperty(key) && item[key] != null)
			{
                if (Object.prototype.toString.call(item[key]) === '[object Array]')
				{
                    for (var i = 0; i < item[key].length; i++)
					{
                        constructElements(item[key][i]);
                    }
                }
				else if (Object.prototype.toString.call(item[key]) === '[object Object]')
				{
                    constructElements(item[key]);
                }
				else
				{
					// syntax example: "fname=Henry&lname=Ford"
					returnString += key + "=" + item[key] + "&"
                }
            }
        }
    }

    //if the parent 'data' object is an array we need to treat it a little differently
    if (Object.prototype.toString.call(data) === '[object Array]')
	{
        if (options.arrayName === undefined)
			console.warn("Posting array-type to url will doubtfully work without an arrayName defined in options.");

        //loop through each array item at the parent level
        for (var i = 0; i < data.length; i++)
		{
            constructElements(data[i], (options.arrayName || "") + "[" + i + "].");
        }
    }
	else
	{
        //otherwise treat it normally
        constructElements(data, "");
    }

	if(returnString.length > 0)
		returnString = returnString.substring(0, returnString.length - 1);

	return returnString;
};

/**
 * Posts javascript data to a url using form.submit().  
 * Note: Handles json and arrays.
 * @param {string} path - url where the data should be sent.
 * @param {string} data - data as javascript object (JSON).
 * @param {object} options -- optional attributes
 *  { 
 *    {string} method: get/post/put/etc,
 *    {string} arrayName: name to post arraylike data.  Only necessary when root data object is an array.
 *  }
 * @example postToUrl('/UpdateUser', {Order {Id: 1, FirstName: 'Sally'}});
 */

function postToUrl(path, data, options)
{
    if (options === undefined)
	{
        options = {};
    }

    var method = options.method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    function constructElements(item, parentString)
	{
        for (var key in item)
		{
            if (item.hasOwnProperty(key) && item[key] != null)
			{
                if (Object.prototype.toString.call(item[key]) === '[object Array]')
				{
                    for (var i = 0; i < item[key].length; i++)
					{
                        constructElements(item[key][i], parentString + key + "[" + i + "].");
                    }
                }
				else if (Object.prototype.toString.call(item[key]) === '[object Object]')
				{
                    constructElements(item[key], parentString + key + ".");
                }
				else
				{
                    var hiddenField = document.createElement("input");
                    hiddenField.setAttribute("type", "hidden");
                    hiddenField.setAttribute("name", parentString + key);
                    hiddenField.setAttribute("value", item[key]);
                    form.appendChild(hiddenField);
                }
            }
        }
    }

    //if the parent 'data' object is an array we need to treat it a little differently
    if (Object.prototype.toString.call(data) === '[object Array]')
	{
        if (options.arrayName === undefined) console.warn("Posting array-type to url will doubtfully work without an arrayName defined in options.");
        //loop through each array item at the parent level
        for (var i = 0; i < data.length; i++)
		{
            constructElements(data[i], (options.arrayName || "") + "[" + i + "].");
        }
    }
	else
	{
        //otherwise treat it normally
        constructElements(data, "");
    }

    document.body.appendChild(form);
    form.submit();
};

function toastSuccess(message)
{
    //$('.toastSuccess').text($(this).data(message)).fadeIn(400).delay(3000).fadeOut(400); 
	$('.toastSuccess').text(message).fadeIn(400).delay(3000).fadeOut(400); 
}

function toastError(message)
{
    //$('.toastError').text($(this).data(message)).fadeIn(400).delay(3000).fadeOut(400); 
	$('.toastError').text(message).fadeIn(400).delay(3000).fadeOut(400); 
}